(JAVA)LeetCode 1. Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

UPDATE (2016/2/13):
The return format had been changed to zero-based indices. Please read the above updated description carefully.

题意:给定一个目标数(target),从给定的整数数组中找出两个数,使得其和为target,并返回这两个数的索引。题目假定解是唯一的,不会出现多组解的情况,因此难度有所降低。

注意:target可以为负数;

另外,因为要求返回的是原始数组的下标,所以不能打乱该数组的顺序,否则下标会乱。即使要打乱,也要对原始数组进行备份。

1.最先想到的是暴力搜索法,使用两层循环,第一层遍历数组,第二层从指定的数往后搜索第二个数,时间复杂度接近O(n^2),AC代码:

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int[] ret=new int[2];
        for(int i=0;i<nums.length;i++){
            for(int j=i+1;j<nums.length;j++){
                if(nums[j]==target-nums[i]){
                    ret[0]=i;
                    ret[1]=j;
                }
            }
        }
        return ret;
    }
}


2.以空间换时间:使用哈希表建立<value,index>的映射关系,遍历数组,在映射表中寻找target-nums[i],若找到则返回两个数的下标,若找不到则将<nums[i],i>加入映射表中,时间复杂度O(n),AC代码:

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int[] ret=new int[2];
        Map<Integer,Integer> map=new HashMap<Integer,Integer>();
        for(int i=0;i<nums.length;i++){
            if(map.containsKey(target-nums[i])){
                ret[0]=map.get(target-nums[i]);
                ret[1]=i;
            }
            map.put(nums[i],i);
        }
        return ret;
    }
}

注:此方法有点投机取巧的意味,因为题目假定答案只有一个解,此时可利用Hash表的对应关系,若为多组解的情况,则该方法不适用

3.排序后搜索

待续

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值